<template>
  <div class="chat-block">
    <div class="chat-block__header">
      <ContactItem :user="user" />
    </div>

    <div class="chat-block-wrap">
      <div class="chat-block__content">
        <ChatMessage
          v-for="(msg, index) in chat" :key="index"
          :message="msg"
          :side="msg.creator === user.nickname ? 'right' : 'left'"
        />
      </div>

      <div class="chat-block__footer">
        <Input
          :maxLength="300"
          :isClearInput="isClearInput"
          @onClearInput="isClearInput = false"
          @onChange="handleMessage"
          @onKeyDownEnter="sendMessage"
        />
        <div @click="sendMessage()">
          <IconBase iconName="paperPlane" class="chat-block__footer--send">
            <paperPlane />
          </IconBase>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, computed, ref, reactive } from '@vue/composition-api'
import Input from 'components/Input.vue'
import ChatMessage from './ChatMessage.vue'
import ContactItem from 'components/ContactItem.vue'
import { User } from 'pages/auth/Auth.vue'
import paperPlane from 'components/icons/paperPlane.vue'

export default defineComponent({
  name: 'ChatBlock',
  components: {
    Input,
    ChatMessage,
    ContactItem,
    paperPlane
  },

  props: {
    user: {
      type: (Object as unknown) as PropType<User>,
      required: true
    }
  },

  setup (props, ctx) {
    const isContacts = ref(true)
    const isMiniContacts = ref(false)
    const splitterModel = ref(50)
    const message = ref('')
    const isClearInput = ref(false)
    const chat = reactive(computed(() => ctx.root.$store.state.main.chat))

    function handleMessage (value: string): void {
      message.value = value
    }

    function sendMessage () {
      if (message.value !== '') {
        ctx.root.$store.dispatch('main/chat', {
          creator: props.user.nickname,
          msg: message.value
        })
        message.value = ''
        isClearInput.value = true
      }
    }

    return {
      isContacts,
      isMiniContacts,
      splitterModel,
      message,
      isClearInput,
      chat,
      handleMessage,
      sendMessage
    }
  }
})
</script>

<style lang="scss" scoped>
@import '../../css/variables';

$headerHeight: 56px;
$indent: 10px;

.chat-block {
  height: 100%;

  &__header {
    align-items: center;
    height: $headerHeight;
    border-bottom: 1px solid rgba(0, 0, 0, 0.12);
    padding: 5px 5px 5px 30px;
    display: flex;
  }

  &-wrap {
    height: calc(100% - #{$headerHeight});
  }

  &__content {
    overflow-y: auto;
    height: calc(100% - #{$headerHeight});
    padding: 1rem;
    background-image: url(../../assets/junior-chat-background.png);
    background-repeat: no-repeat;
    background-attachment: fixed;
    background-size: cover;
  }

  &__footer {
    align-items: center;
    height: $headerHeight;
    border-top: 1px solid rgba(0, 0, 0, 0.12);
    padding: $indent;
    display: flex;

    &>*:first-child {
      width: 100%;
      height: 30px;
    }

    &--send {
      width: 40px;
      height: 40px;
      margin-left: $indent;
      cursor: pointer;
    }
  }
}
</style>
